/* tmnr6r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Initialized data */
    static float x[2] = { -1.2f,1.f };
    static float tmax = 30.f;
    static int n = 2;
    static float xe[2] = { 1e-18f,1e-18f };
    static float fe = 1e-18f;
    static float a[2] = { -1.3f,.5f };
    static float b[2] = { .5f,1.f };
    static int i0[2] = { 1,1 };
    static float rm[15] = { 100.f };
    static float ge[2] = { 1e-10f,1e-10f };
    static float up[4] = { 1e-15f,10.f,1.2f,100.f };

    /* Local variables */
    extern int grad_c(), func_c();
    static int ierr;
    extern int mnr6r_c(float *, float *, int *, float *, float *, int *,
                       U_fp, float *, float *, U_fp, float *, float *,
                       float *, float *, int *, float *, int *);
    static float f, g[2];
    extern int utmn05_c(float *);
    static float t0, t1, dt;
    static int irm[2];

    utmn05_c(&t0);
    printf("\n %11.3e %11.3e \n", x[0], x[1]);
    printf("\n %11.3e %11.3e \n", a[0], a[1]);
    printf("\n %11.3e %11.3e \n", b[0], b[1]);
    printf("\n %11.3e %11.3e \n", xe[0], xe[1]);
    printf("\n %11.3e \n", fe);
    printf("\n %11.3e %11.3e \n", ge[0], ge[1]);
    printf("\n %11.3e %11.3e %11.3e %11.3e \n\n", up[0], up[1], up[2], up[3]);

    mnr6r_c(x, xe, i0, a, b, &n, (U_fp)func_c, &f, &fe, (U_fp)grad_c, g, ge,
            up, rm, irm, &tmax, &ierr);

    utmn05_c(&t1);
    dt = t1 - t0;
    printf("\n %11.3e %11.3e %11.3e \n", rm[0], rm[1], rm[2]);
    printf("\n %5i \n", ierr);
    printf("\n %11.3e %11.3e \n", f);
    printf("\n %11.3e %11.3e \n", x[0], x[1]);
    printf("\n %11.3e %11.3e \n", g[0], g[1]);
    printf("\n %6.2f \n", dt);
    return 0;
} /* main */

int func_c(float *x, float *f, float *fe)
{
    /* System generated locals */
    float r__1, r__2, r__3;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__2 = x[1];
/* Computing 2nd power */
    r__1 = x[2] - r__2 * r__2;
/* Computing 2nd power */
    r__3 = 1.f - x[1];
    *f = r__1 * r__1 + r__3 * r__3;
    return 0;
} /* func_c */

int grad_c(float *x, float *g, float *ge, int *i0)
{
    /* System generated locals */
    float r__1;

    /* Parameter adjustments */
    --i0;
    --ge;
    --g;
    --x;

    /* Function Body */
    g[1] = 0.f;
    if (i0[1] == 0) {
        goto L10;
    }
/* Computing 2nd power */
    r__1 = x[1];
    g[1] = (x[2] - r__1 * r__1) * -4.f * x[1] - (1.f - x[1]) * 2.f;
L10:
    g[2] = 0.f;
    if (i0[2] == 0) {
        goto L20;
    }
/* Computing 2nd power */
    r__1 = x[1];
    g[2] = (x[2] - r__1 * r__1) * 2.f;
L20:
    return 0;
} /* grad_c */
